<?php
if( ! defined( 'ABSPATH' ) ) return;

class gnupay_inicis_returnurl extends WC_Settings_API { 
    public function __construct() {
        add_action('woocommerce_api_'.__CLASS__, array($this, 'return_process') );
    }

	public function get_return_url( $order = null ) {

		if ( $order ) {
			$return_url = $order->get_checkout_order_received_url();
		} else {
			$return_url = wc_get_endpoint_url( 'order-received', '', wc_get_page_permalink( 'checkout' ) );
		}

		if ( is_ssl() || get_option('woocommerce_force_ssl_checkout') == 'yes' ) {
			$return_url = str_replace( 'http:', 'https:', $return_url );
		}

		return apply_filters( 'woocommerce_get_return_url', $return_url, $order );
	}

    public function return_process(){
        
		//잘못된 파라미터가 있다면 수정
		if( isset($_REQUEST['inicispay']) && strstr($_REQUEST['inicispay'], '?') ){
			$tmp = explode('?', $_REQUEST['inicispay']);
			
			for($i=0,$tmp_count=count($tmp);$i<$tmp_count;$i++){
				if($i === 0){
					$_REQUEST['inicispay'] = $tmp[$i];
				} else {
					$arr = explode('=', $tmp[$i]);
					if( $arr[0] ){
						$_REQUEST[$arr[0]] = isset($arr[1]) ? (string)sanitize_text_field($arr[1]) : '';
					}
				}
			}
		}

        $inicispay = isset($_REQUEST['inicispay']) ? sanitize_text_field($_REQUEST['inicispay']) : '';

        $return_plugin_id = $this->plugin_id;

        switch ($inicispay) {
            case 'next' :
                include_once(GNUPAY_INICIS_PATH.'inicis/m_next.php');
                break;
            case 'noti' :
                include_once(GNUPAY_INICIS_PATH.'inicis/m_noti.php');
                break;
            case 'return' :
                include_once(GNUPAY_INICIS_PATH.'inicis/returnurl.php');
                break;
            case 'close' :
                echo '<script language="javascript" type="text/javascript" src="https://stdpay.inicis.com/stdjs/INIStdPay_close.js" charset="UTF-8"></script>';
                break;
            case 'popup' :
                echo '<script language="javascript" type="text/javascript" src="https://stdpay.inicis.com/stdjs/INIStdPay_popup.js" charset="UTF-8"></script>';
                break;
        }

        if( !$inicispay ){
            wp_redirect(home_url());
        }
        exit;
    }
}

new gnupay_inicis_returnurl();
?>