<?php
if( ! defined( 'ABSPATH' ) ) return;

class inicis_virtualaccount extends inicis_card_gateway
{

    public function get_the_id() {
        $pay_ids = gnupay_inicis_get_settings('pay_ids');

        return $pay_ids['vbank'];   //가상계좌
    }

    public function __construct() {
        parent::__construct();

        add_action('woocommerce_api_'.__CLASS__, array($this, 'api_request') );
    }

    public function get_the_title(){
        return __('INICIS 가상계좌', GNUPAY_INICIS);
    }

    public function get_the_description() {

        /*
        if( $error = $this->pay_bin_check() ){
        }
        */

        $description = __( 'KG Inicis 가상계좌 입금통보 URL은 아래와 같습니다.', GNUPAY_INICIS )."<br><br><font size=\"3em\">".gnupay_inicis_get_vbankurl()."</font><br><br>";

        return $description.__( 'KG이니시스 가상계좌 사용시 다음 주소를 <strong><a href="https://iniweb.inicis.com/" target="_blank">KG이니시스 관리자</a> &gt; 거래조회 &gt; 가상계좌 &gt; 입금통보방식선택 &gt; URL 수신 설정</strong>에 넣으셔야 상점에 자동으로 입금 통보됩니다.', GNUPAY_INICIS);
    }

    public function is_valid_for_use(){

        $is_vaild = true;

        if( ! in_array( get_woocommerce_currency(), array('KRW') ) ){
            return false;
        }

        $inicis_options = gp_inicis_get_card_options();

        if( !$inicis_options['de_card_test'] && trim($inicis_options['de_inicis_mid']) == '' ){     //실결제일때 사이트키가 없으면
            return false;
        }

        return $is_vaild;
    }

    public function init_form_fields(){
        $config = $this->config;

        $this->form_fields = array(
            'enabled' => array(
                'title' => __('Enable/Disable', 'woocommerce'),
                'type' => 'checkbox',
                'label' => sprintf(__('%s 를 활성화합니다.', GNUPAY_INICIS), $this->get_the_title()),
                'default' => 'no',
            ),
            'title' => array(
                'title' => __('Title', 'woocommerce'),
                'type' => 'text',
                'default' => $this->get_the_title(),
            ),
            'description' => array(
                'title' => __('Description', 'woocommerce'),
                'type' => 'textarea',
                'default' => sprintf(__('%s 로 결제합니다.', GNUPAY_INICIS), $this->get_the_title()),
            ),
            'instructions' => array(
                'title' => __('Instructions', 'woocommerce'),
                'type' => 'textarea',
                'description' => __('Instructions that will be added to the thank you page.', 'woocommerce'),
                'default' => '',
                'desc_tip' => true,
            ),
            'de_pay_complete_status'     =>  array(
                'title' => __( '가상계좌 입금 요청전 주문상태', GNUPAY_INICIS ),
                'description'   =>  __( 'INICIS 가상계좌 입금 요청전 주문상태를 지정합니다.', GNUPAY_INICIS ),
                'type'              => 'select',
                'class'             => 'wc-enhanced-select',
                'css'               => 'width: 450px;',
                'label' => __( '가상계좌 입금 요청전 주문상태', GNUPAY_INICIS ),
                'default' => 'wc-on-hold',
                'options' => wc_get_order_statuses(),
				'desc_tip'          => true,
				'custom_attributes' => array(
					'data-placeholder' => __('선택해 주세요.', GNUPAY_INICIS )
				)
            ),
            'de_deposit_after_status'     =>  array(
                'title' => __( '가상계좌 입금 후 주문상태', GNUPAY_INICIS ),
                'description'   =>  __( '가상계좌 입금 후 주문상태를 지정합니다.', GNUPAY_INICIS ),
                'type'              => 'select',
                'class'             => 'wc-enhanced-select',
                'css'               => 'width: 450px;',
                'label' => __( '가상계좌 입금 후 주문상태 주문상태', GNUPAY_INICIS ),
                'default' => 'wc-processing',
                'options' => wc_get_order_statuses(),
				'desc_tip'          => true,
				'custom_attributes' => array(
					'data-placeholder' => __('선택해 주세요.', GNUPAY_INICIS )
				)
            ),
            'de_deposit_period'     =>  array(
                'title' => __( '가상계좌 입금 기간 설정', GNUPAY_INICIS ),
                'description'   =>  __( '가상계좌 입금 기간을 설정합니다.', GNUPAY_INICIS ),
                'type'              => 'select',
                'class'             => 'wc-enhanced-select',
                'css'               => 'width: 450px;',
                'label' => __( '가상계좌 입금 후 주문상태 주문상태', GNUPAY_INICIS ),
                'default' => '6',
                'options' => array( '2'=>'2', '3'=>'3', '4'=>'4', '5'=>'5', '6'=>'6', '7'=>'7' ),
				'desc_tip'          => true,
				'custom_attributes' => array(
					'data-placeholder' => __('선택해 주세요.', GNUPAY_INICIS )
				)
            ),
        );
    }

    //가상계좌 입금 처리

    public function api_request(){

        if( $config = $this->config ){
            
            //**********************************************************************************
            //이니시스가 전달하는 가상계좌이체의 결과를 수신하여 DB 처리 하는 부분 입니다.
            //필요한 파라메터에 대한 DB 작업을 수행하십시오.
            //**********************************************************************************

            //**********************************************************************************
            //  이부분에 로그파일 경로를 수정해주세요.

            $INIpayHome = GNUPAY_INICIS_PATH.'/inicis'; // 이니페이 홈디렉터리
            $INIpayLog  = apply_filters('gp_inicis_log_enable', true);                  // 로그를 기록하려면 true 로 수정

            //**********************************************************************************

            $PG_IP = $_SERVER['REMOTE_ADDR'];

            if( $PG_IP == "203.238.37.3" || $PG_IP == "203.238.37.15" || $PG_IP == "203.238.37.16" || $PG_IP == "203.238.37.25" || $PG_IP == "39.115.212.9" )  //PG에서 보냈는지 IP로 체크
            {
                if($INIpayLog) {
                    try {
                        $logfile = fopen( gp_inicis_upload_path() . "/log/post_result".date("Ymd").".log", "a+" );    //로그기록 임의 수정

                        fwrite( $logfile,"************************************************");
                        fwrite( $logfile, var_export($_POST, true) );   //로그기록
                        fwrite( $logfile, "\r\n");

                        fclose( $logfile );
                    } catch (Exception $e) {
                        //echo 'Caught exception: ',  $e->getMessage(), "\n";
                    }
                }
            }

            $check_array = array(
                'msg_id',   //메세지 타입
                'no_tid',   //거래번호
                'no_oid',   //상점 주문번호
                'id_merchant',  //상점 아이디
                'cd_bank',  //거래 발생 기관 코드
                'cd_deal',  //취급 기관 코드
                'dt_trans', //거래 일자
                'tm_trans', //거래 시간
                'no_msgseq',    //전문 일련 번호
                'cd_joinorg',   //제휴 기관 코드
                'dt_transbase', //거래 기준 일자
                'no_transeq',   //거래 일련 번호
                'type_msg', //거래 구분 코드
                'cl_close',
                'cl_kor',
                'no_msgmanage', //전문 관리 번호
                'no_vacct',         //가상계좌번호
                'amt_input',      //입금금액
                'amt_check',      //미결제 타점권 금액
                'nm_inputbank', //입금 금융기관명
                'nm_input',       //입금 의뢰인
                'dt_inputstd',   //입금 기준 일자
                'dt_calculstd', //정산 기준 일자
                'flg_close',       //마감 전화

                //가상계좌채번시 현금영수증 자동발급신청시에만 전달
                'dt_cshr',       //현금영수증 발급일자
                'tm_cshr',       //현금영수증 발급시간
                'no_cshr_appl',  //현금영수증 발급번호
                'no_cshr_tid',   //현금영수증 발급TID
            );

            $tmp_arr = array();
            foreach( $check_array as $v ){
                $tmp_arr[$v] = isset($_POST[$v]) ? sanitize_text_field($_POST[$v]) : ''; 
            }
            
            extract( $tmp_arr );

            // 입금결과 처리

            $order_id = gp_inicis_replace_oid($no_oid);
            $result = false;

            if( $order = wc_get_order( $order_id ) ){

                $order_tno = get_post_meta( $order_id, '_od_tno', true );
                $pay_options = get_option( $this->plugin_id . $this->id . '_settings' );

                if( ! $order->get_order_number() ){
                    return;
                }

                /*
                if( isset($no_cshr_tid) && $order_tno != $no_cshr_tid ){    //재전송 통보는 no_cshr_tid값이 넘어오지 않는다.
                    $order->add_order_note( __('해당 주문번호랑 틀린 잘못된 pg 요청이 들어왔습니다.', GNUPAY_INICIS) );
                    return;
                }
                */

                $od_vact_data = get_post_meta( $order_id, '_od_vact_data', true );
                
                if( !$od_vact_data ){
                    update_post_meta($order_id, '_od_vact_data', $tmp_arr);   //배열 전체를 저장
                    update_post_meta($order_id, '_od_receipt_price', isset($amt_input) ? $amt_input : '');   //입금한 금액
                    update_post_meta($order_id, '_od_receipt_time', isset($dt_inputstd) ? $dt_inputstd : '');   //입금처리한 시간
                }
                
                // 주문정보 체크 ( 업데이트 처리 )
                $order->update_status( sir_inicis_get_order_status($pay_options['de_deposit_after_status']), sprintf(__( '가상계좌에 금액 %s 이 입금 되었습니다 .  ', GNUPAY_INICIS ), (float) $amt_input ) );

                $result = true;
            }

            if($INIpayLog) {
                try {
                    $logfile = fopen( gp_inicis_upload_path() . "/log/result.log", "a+" );    //로그 기록 임의 수정

                    fwrite( $logfile,"************************************************");
                    fwrite( $logfile,"ID_MERCHANT : ".$id_merchant."\r\n");
                    fwrite( $logfile,"NO_TID : ".$no_tid."\r\n");
                    fwrite( $logfile,"NO_OID : ".$no_oid."\r\n");
                    fwrite( $logfile,"NO_VACCT : ".$no_vacct."\r\n");
                    fwrite( $logfile,"AMT_INPUT : ".$amt_input."\r\n");
                    fwrite( $logfile,"NM_INPUTBANK : ".$nm_inputbank."\r\n");
                    fwrite( $logfile,"NM_INPUT : ".$nm_input."\r\n");
                    fwrite( $logfile,"************************************************");

                    fwrite( $logfile,"전체 결과값"."\r\n");
                    fwrite( $logfile, $msg_id."\r\n");
                    fwrite( $logfile, $no_tid."\r\n");
                    fwrite( $logfile, $no_oid."\r\n");
                    fwrite( $logfile, $id_merchant."\r\n");
                    fwrite( $logfile, $cd_bank."\r\n");
                    fwrite( $logfile, $dt_trans."\r\n");
                    fwrite( $logfile, $tm_trans."\r\n");
                    fwrite( $logfile, $no_msgseq."\r\n");
                    fwrite( $logfile, $type_msg."\r\n");
                    fwrite( $logfile, $cl_close."\r\n");
                    fwrite( $logfile, $cl_kor."\r\n");
                    fwrite( $logfile, $no_msgmanage."\r\n");
                    fwrite( $logfile, $no_vacct."\r\n");
                    fwrite( $logfile, $amt_input."\r\n");
                    fwrite( $logfile, $amt_check."\r\n");
                    fwrite( $logfile, $nm_inputbank."\r\n");
                    fwrite( $logfile, $nm_input."\r\n");
                    fwrite( $logfile, $dt_inputstd."\r\n");
                    fwrite( $logfile, $dt_calculstd."\r\n");
                    fwrite( $logfile, $flg_close."\r\n");
                    fwrite( $logfile, "\r\n");

                    fclose( $logfile );
                } catch (Exception $e) {
                    //echo 'Caught exception: ',  $e->getMessage(), "\n";
                }
            }

            //위에서 상점 데이터베이스에 등록 성공유무에 따라서 성공시에는 "OK"를 이니시스로
            //리턴하셔야합니다. 아래 조건에 데이터베이스 성공시 받는 FLAG 변수를 넣으세요
            //(주의) OK를 리턴하지 않으시면 이니시스 지불 서버는 "OK"를 수신할때까지 계속 재전송을 시도합니다
            //기타 다른 형태의 PRINT( echo )는 하지 않으시기 바랍니다

            if ($result !== false)
            {
                echo "OK";                        // 절대로 지우지마세요
            }
            else
            {
                echo "DB Error";
            }
            
            exit;

        }   //end if config
    }   //end function api_request

    public function process_admin_options(){

        $result = parent::process_admin_options();
    
        if( $result ){
            $options = apply_filters( 'woocommerce_settings_api_sanitized_fields_' . $this->id, $this->setttings );

            $inicis_options = get_option( $this->plugin_id . $this->gnupay_inicis_card . '_settings' );
            
            $op_enabled = $options['enabled'] == 'yes' ? 1 : 0;

            if(isset($inicis_options['de_vbank_use']) && $op_enabled != $inicis_options['de_vbank_use']){

                $inicis_options['de_vbank_use'] = $op_enabled;

                update_option( $this->plugin_id . $this->gnupay_inicis_card . '_settings', $inicis_options );
            }
        }

        return $result;

    }

}   //end class inicis_virtualaccount
?>