<?php
if( ! defined( 'ABSPATH' ) ) return;

global $woocommerce;

$oid  = isset($_REQUEST['P_NOTI']) ? sanitize_text_field($_REQUEST['P_NOTI']) : '';
$order_id = gp_inicis_replace_oid($oid);
$config = gnupay_inicis_get_config_payment( $order_id );
$pay_ids = gnupay_inicis_get_settings('pay_ids');

// 반드시 위의 config 값을 받아온후 settle_inicis.inc.php 를 include 해야 한다
include_once(GNUPAY_INICIS_PATH.'inicis/settle_inicis.inc.php');

// 세션 초기화
gp_inicis_set_session('P_TID',  '');
gp_inicis_set_session('P_AMT',  '');
gp_inicis_set_session('P_HASH', '');

$p_status = isset($_REQUEST['P_STATUS']) ? sanitize_text_field($_REQUEST['P_STATUS']) : '';
$checkout_url = $woocommerce->cart->get_checkout_url();
$p_rmesg1 = isset($_REQUEST['P_RMESG1']) ? sanitize_text_field(gp_inicis_iconv_utf8($_REQUEST['P_RMESG1'])) : '';
$p_tid = isset($_REQUEST['P_TID']) ? sanitize_text_field($_REQUEST['P_TID']) : '';

//세션값이 넘어오지 않았으면
if( !$oid ){
    wp_die( __('P_NOTI 값이 넘어 오지 않았습니다.', GNUPAY_INICIS) );
}

$data = get_post_meta( $order_id, '_order_tmp_inicis', true );

$data = maybe_unserialize(base64_decode($data));

if( $p_status != '00' ){
    gp_alert('오류 : '.$p_rmesg1.' 코드 : '.$p_status, $checkout_url);
} else {
    $post_data = array(
        'P_MID' => $config['de_inicis_mid'],
        'P_TID' => $p_tid
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $_REQUEST['P_REQ_URL']);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $return = curl_exec($ch);

    if(!$return)
        gp_alert(__('KG이니시스와 통신 오류로 결제등록 요청을 완료하지 못했습니다.\\n결제등록 요청을 다시 시도해 주십시오.', GNUPAY_INICIS), $checkout_url);

    // 결과를 배열로 변환
    parse_str($return, $ret);
    $PAY = array_map('trim', $ret);
    $PAY = array_map('strip_tags', $PAY);
    $PAY = array_map('sanitize_text_field', $PAY);

    if($PAY['P_STATUS'] != '00')
        gp_alert('오류 : '.gp_inicis_iconv_utf8($PAY['P_RMESG1']).' 코드 : '.$PAY['P_STATUS'], $checkout_url);

    // TID, AMT 를 세션으로 주문완료 페이지 전달
    $hash = md5($PAY['P_TID'].$PAY['P_MID'].$PAY['P_AMT']);
    gp_inicis_set_session('P_TID',  $PAY['P_TID']);
    gp_inicis_set_session('P_AMT',  $PAY['P_AMT']);
    gp_inicis_set_session('P_HASH', $hash);
}

$defalut_array = array(
    'P_HPP_CORP' =>  '',
    'P_APPL_NUM'    =>  '',
    'P_VACT_NUM'    =>  '',
    'P_VACT_NAME'   =>  '',
    'P_VACT_BANK_CODE'  =>  '',
    'P_CARD_ISSUER_CODE'    =>  '',
    'P_UNAME'   =>  '',
    );

$PAY = wp_parse_args($PAY, $defalut_array);

$exclude = array('res_cd', 'P_HASH', 'P_TYPE', 'P_AUTH_DT', 'P_AUTH_NO', 'P_HPP_CORP', 'P_APPL_NUM', 'P_VACT_NUM', 'P_VACT_NAME', 'P_VACT_BANK', 'P_CARD_ISSUER', 'P_UNAME');

// 받아온 값으로 결제처리를 한다.
$order_id = gp_inicis_replace_oid($PAY['P_OID']);
$pid = $payment_method = get_post_meta( $order_id, '_payment_method', true );
$payment_title = get_post_meta( $order_id, '_payment_method_title', true );
$escw_yn = '';
$app_no = $PAY["P_AUTH_NO"]; //승인번호;

$real_paymethod = isset( $PAY['P_TYPE'] ) ? $PAY['P_TYPE'] : '';

if( $real_paymethod && $method_check = gnupay_inicis_payment_check( $order_id, $real_paymethod, $payment_method, $payment_title, $pay_ids ) ){      //payment_method 가 변했는지 체크
    
    if( $method_check['change'] ){
        $pid = $payment_method = $method_check['payment_method'];
        $payment_title = $method_check['payment_title'];
    }

}

$pay_result = array(
    'tot_price' => $PAY['P_AMT'], //결제완료금액
    'tno' => $PAY['P_TID'], //PG 거래번호
    'mid' => $PAY['P_MID'], //가맹점 ID ( 테스트 결제인 경우 INIpayTest )
    'vactbankname' => $PAY['P_VACT_BANK_CODE'],  // 입금할 은행 이름
    'vactname' => $PAY['P_VACT_NAME'],  // 입금할 계좌 예금주
    'vactnum' => $PAY['P_VACT_NUM'], // 입금할 계좌 번호
    'vactdate' => '',     // 가상계좌 입금마감시간
);

include_once(GNUPAY_INICIS_PATH.'inicis/pay_success_common.php');

$return_url = $this->get_return_url( $order );

gp_inicis_loading_msg( $return_url );

exit;
?>