<?php
if( ! defined( 'ABSPATH' ) ) return;

//*******************************************************************************
// FILE NAME : mx_rnoti.php
// FILE DESCRIPTION :
// 이니시스 smart phone 결제 결과 수신 페이지 샘플
// 기술문의 : ts@inicis.com
// HISTORY 
// 2010. 02. 25 최초작성 
// 2010  06. 23 WEB 방식의 가상계좌 사용시 가상계좌 채번 결과 무시 처리 추가(APP 방식은 해당 없음!!)
// WEB 방식일 경우 이미 P_NEXT_URL 에서 채번 결과를 전달 하였으므로, 
// 이니시스에서 전달하는 가상계좌 채번 결과 내용을 무시 하시기 바랍니다.
//*******************************************************************************

  $PGIP = $_SERVER['REMOTE_ADDR'];
  
  if($PGIP == "211.219.96.165" || $PGIP == "118.129.210.25" || $PGIP == "183.109.71.153")	//PG에서 보냈는지 IP로 체크
  {

		// 이니시스 NOTI 서버에서 받은 Value
		$P_TID;				// 거래번호
		$P_MID;				// 상점아이디
		$P_AUTH_DT;			// 승인일자
		$P_STATUS;			// 거래상태 (00:성공, 01:실패)
		$P_TYPE;			// 지불수단
		$P_OID;				// 상점주문번호
		$P_FN_CD1;			// 금융사코드1
		$P_FN_CD2;			// 금융사코드2
		$P_FN_NM;			// 금융사명 (은행명, 카드사명, 이통사명)
		$P_AMT;				// 거래금액
		$P_UNAME;			// 결제고객성명
		$P_RMESG1;			// 결과코드
		$P_RMESG2;			// 결과메시지
		$P_NOTI;			// 노티메시지(상점에서 올린 메시지)
		$P_AUTH_NO;			// 승인번호
	

		$P_TID = isset($_REQUEST['P_TID']) ? gp_check_array_sanitize($_REQUEST['P_TID']) : '';
		$P_MID = isset($_REQUEST['P_MID']) ? gp_check_array_sanitize($_REQUEST['P_MID']) : '';
		$P_AUTH_DT = isset($_REQUEST['P_AUTH_DT']) ? gp_check_array_sanitize($_REQUEST['P_AUTH_DT']) : '';
		$P_STATUS = isset($_REQUEST['P_STATUS']) ? gp_check_array_sanitize($_REQUEST['P_STATUS']) : '';
		$P_TYPE = isset($_REQUEST['P_TYPE']) ? gp_check_array_sanitize($_REQUEST['P_TYPE']) : '';
		$P_OID = isset($_REQUEST['P_OID']) ? gp_check_array_sanitize($_REQUEST['P_OID']) : '';
		$P_FN_CD1 = isset($_REQUEST['P_FN_CD1']) ? gp_check_array_sanitize($_REQUEST['P_FN_CD1']) : '';
		$P_FN_CD2 = isset($_REQUEST['P_FN_CD2']) ? gp_check_array_sanitize($_REQUEST['P_FN_CD1']) : '';
		$P_FN_NM = isset($_REQUEST['P_FN_NM']) ? gp_check_array_sanitize($_REQUEST['P_FN_NM']) : '';
		$P_AMT = isset($_REQUEST['P_AMT']) ? gp_check_array_sanitize($_REQUEST['P_AMT']) : '';
		$P_UNAME = isset($_REQUEST['P_UNAME']) ? gp_check_array_sanitize($_REQUEST['P_UNAME']) : '';
		$P_RMESG1 = isset($_REQUEST['P_RMESG1']) ? gp_check_array_sanitize($_REQUEST['P_RMESG1']) : '';
		$P_RMESG2 = isset($_REQUEST['P_RMESG2']) ? gp_check_array_sanitize($_REQUEST['P_RMESG2']) : '';
		$P_NOTI = isset($_REQUEST['P_NOTI']) ? gp_check_array_sanitize($_REQUEST['P_NOTI']) : '';
		$P_AUTH_NO = isset($_REQUEST['P_AUTH_NO']) ? gp_check_array_sanitize($_REQUEST['P_AUTH_NO']) : '';


		//WEB 방식의 경우 가상계좌 채번 결과 무시 처리
		//(APP 방식의 경우 해당 내용을 삭제 또는 주석 처리 하시기 바랍니다.)
		 if($P_TYPE == "VBANK")	//결제수단이 가상계좌이며
        	{
           	   if($P_STATUS != "02") //입금통보 "02" 가 아니면(가상계좌 채번 : 00 또는 01 경우)
           	   {
	              echo "OK";
        	      return;
           	   }
        	}
 
        //결제 결과가 성공했다면

        if($P_STATUS == "00"){
            // 주문정보 업데이트

            // 받아온 값으로 결제처리를 한다.
            $order_id = gp_inicis_replace_oid($P_OID);
            $config = gnupay_inicis_get_config_payment( $order_id );
            $pid = $payment_method = get_post_meta( $order_id, '_payment_method', true );
            $payment_title = get_post_meta( $order_id, '_payment_method_title', true );
            $pay_ids = gnupay_inicis_get_settings('pay_ids');
            $escw_yn = '';
            $is_noti = true;
			$noti_tno = get_post_meta( $order_id, '_od_tno', true );
            $app_no = $P_AUTH_NO; //승인번호;

            update_post_meta($order_id, '_is_noti', 1);   //inicis noti로 받아온건지 수정

            $real_paymethod = isset( $P_TYPE ) ? $P_TYPE : '';

            if( $real_paymethod && $method_check = gnupay_inicis_payment_check( $order_id, $real_paymethod, $payment_method, $payment_title, $pay_ids ) ){      //payment_method 가 변했는지 체크
                
                if( $method_check['change'] ){
                    $pid = $payment_method = $method_check['payment_method'];
                    $payment_title = $method_check['payment_title'];
                }

            }

            // 반드시 위의 config 값을 받아온후 settle_inicis.inc.php 를 include 해야 한다
            include_once(GNUPAY_INICIS_PATH.'inicis/settle_inicis.inc.php');

            $pay_result = array(
                'tot_price' => $P_AMT, //결제완료금액
                'tno' => $P_TID, //PG 거래번호
                'mid' => $P_MID, //가맹점 ID ( 테스트 결제인 경우 INIpayTest )
                'vactbankname' => '',  // 입금할 은행 이름
                'vactname' => '',  // 입금할 계좌 예금주
                'vactnum' => '', // 입금할 계좌 번호
                'vactdate' => '',     // 가상계좌 입금마감시간
            );

            include_once(GNUPAY_INICIS_PATH.'inicis/pay_success_common.php');

			$order_result = true;
        }


		/***********************************************************************************
		 ' 위에서 상점 데이터베이스에 등록 성공유무에 따라서 성공시에는 "OK"를 이니시스로 실패시는 "FAIL" 을
		 ' 리턴하셔야합니다. 아래 조건에 데이터베이스 성공시 받는 FLAG 변수를 넣으세요
		 ' (주의) OK를 리턴하지 않으시면 이니시스 지불 서버는 "OK"를 수신할때까지 계속 재전송을 시도합니다
		 ' 기타 다른 형태의 echo "" 는 하지 않으시기 바랍니다
		'***********************************************************************************/
	
		// if(데이터베이스 등록 성공 유무 조건변수 = true)
		if($order_result){
			$order_message = "OK";
		    echo "OK"; //절대로 지우지 마세요
		} else {
			$order_message = "FAIL";
			echo "FAIL";
		}

  		$PageCall_time = date("Ymd H:i:s");

		$value = array(
				"PageCall time" => $PageCall_time,
				"P_TID"			=> $P_TID,  
				"P_MID"     => $P_MID,  
				"P_AUTH_DT" => $P_AUTH_DT,      
				"P_STATUS"  => $P_STATUS,
				"P_TYPE"    => $P_TYPE,     
				"P_OID"     => $P_OID,  
				"P_FN_CD1"  => $P_FN_CD1,
				"P_FN_CD2"  => $P_FN_CD2,
				"P_FN_NM"   => $P_FN_NM,  
				"P_AMT"     => $P_AMT,  
				"P_UNAME"   => $P_UNAME,  
				"P_RMESG1"  => $P_RMESG1,  
				"P_RMESG2"  => $P_RMESG2,
				"P_NOTI"    => $P_NOTI,  
				"P_AUTH_NO" => $P_AUTH_NO,
                "P_return" => $order_message,
				);
 

 			// 결제처리에 관한 로그 기록
 		gp_inicis_writeLog($value);

  }

function gp_inicis_writeLog($msg)
{
    if( $log_path = apply_filters('gp_inicis_log_path', gp_inicis_upload_path()) ){
        $file = $log_path."/noti_input_".date("Ymd").".log";

        if(!($fp = fopen($path.$file, "a+"))) return 0;
                    
        ob_start();
        print_r($msg);
        $ob_msg = ob_get_contents();
        ob_clean();
            
        if(fwrite($fp, " ".$ob_msg."\n") === FALSE)
        {
            fclose($fp);
            return 0;
        }
        fclose($fp);
        return 1;
    }
}

exit;
?>