<?php
if( ! defined( 'ABSPATH' ) ) exit; // 개별 페이지 접근 불가

$mobile = isset($_REQUEST['mobile']) ? sanitize_text_field($_REQUEST['mobile']) : '';

if( GNUPAY_INICIS_MOBILE && $mobile ){ //모바일 요청이면
    include( __DIR__ ."/m_returnurl.php");
    return;
}

$orderNumber = isset($_REQUEST['orderNumber']) ? sanitize_text_field($_REQUEST['orderNumber']) : '';
$order_id = gp_inicis_replace_oid($orderNumber);

if( !$order_id ){
    wp_die(__('주문번호 값이 없습니다.', GNUPAY_INICIS));
}

$config = gnupay_inicis_get_config_payment($order_id);

if( !$config ){
    wp_die(__('주문번호 값과 이니시스 설정값이 맞지 않습니다.', GNUPAY_INICIS));
}

$pid = $payment_method = get_post_meta( $order_id, '_payment_method', true );
$payment_title = get_post_meta( $order_id, '_payment_method_title', true );
$pay_ids = gnupay_inicis_get_settings('pay_ids');

if( !$pid || !in_array($pid, $pay_ids) ){
    wp_die(__('해당 주문번호가 이니시스 결제로 등록되지 않았습니다.', GNUPAY_INICIS));
}

require_once(GNUPAY_INICIS_PATH.'lib/INIStdPayUtil.php');
require_once(GNUPAY_INICIS_PATH.'lib/HttpClient.php');
$util = new INIStdPayUtil();

try {

    //#############################
    // 인증결과 파라미터 일괄 수신
    //#############################
    //		$var = $_REQUEST["data"];
    //		System.out.println("paramMap : "+ paramMap.toString());
    //#####################
    // 인증이 성공일 경우만
    //#####################
    if (strcmp("0000", $_REQUEST["resultCode"]) == 0) {

        //"####인증성공/승인요청####";

        //############################################
        // 1.전문 필드 값 설정(***가맹점 개발수정***)
        //############################################

        $mid = isset($_REQUEST["mid"]) ? gp_check_array_sanitize($_REQUEST["mid"]) : '';     // 가맹점 ID 수신 받은 데이터로 설정
        
        $signKey = $config['de_inicis_web_signkey']; // 가맹점에 제공된 웹 표준 사인키(가맹점 수정후 고정);

        if( $config['de_card_test'] ){  //테스트결제이면
            $signKey = "SU5JTElURV9UUklQTEVERVNfS0VZU1RS"; // 가맹점에 제공된 키(이니라이트키) (가맹점 수정후 고정) !!!절대!! 전문 데이터로 설정금지
        }

        $timestamp = $util->getTimestamp();   // util에 의해서 자동생성

        $charset = "UTF-8";        // 리턴형식[UTF-8,EUC-KR](가맹점 수정후 고정)

        $format = "JSON";        // 리턴형식[XML,JSON,NVP](가맹점 수정후 고정)
        // 추가적 noti가 필요한 경우(필수아님, 공백일 경우 미발송, 승인은 성공시, 실패시 모두 Noti발송됨) 미사용 
        //String notiUrl	= "";

        //authToken 은 필터링 하지 않는다.
        $authToken = isset($_REQUEST["authToken"]) ? $_REQUEST["authToken"] : '';   // 취소 요청 tid에 따라서 유동적(가맹점 수정후 고정)

        $authUrl = isset($_REQUEST["authUrl"]) ? sanitize_text_field($_REQUEST["authUrl"]) : '';    // 승인요청 API url(수신 받은 값으로 설정, 임의 세팅 금지)

        $netCancel = isset($_REQUEST["netCancelUrl"]) ? sanitize_text_field($_REQUEST["netCancelUrl"]) : '';   // 망취소 API url(수신 받은f값으로 설정, 임의 세팅 금지)

        //#####################
        // 2.signature 생성
        //#####################
        $signParam["authToken"] = $authToken;  // 필수
        $signParam["timestamp"] = $timestamp;  // 필수
        // signature 데이터 생성 (모듈에서 자동으로 signParam을 알파벳 순으로 정렬후 NVP 방식으로 나열해 hash)
        $signature = $util->makeSignature($signParam);

        //#####################
        // 3.API 요청 전문 생성
        //#####################
        $authMap["mid"] = $mid;   // 필수
        $authMap["authToken"] = $authToken; // 필수
        $authMap["signature"] = $signature; // 필수
        $authMap["timestamp"] = $timestamp; // 필수
        $authMap["charset"] = $charset;  // default=UTF-8
        $authMap["format"] = $format;  // default=XML
        //if(null != notiUrl && notiUrl.length() > 0){
        //	authMap.put("notiUrl"		,notiUrl);
        //}

        try {

            $httpUtil = new HttpClient();

            //#####################
            // 4.API 통신 시작
            //#####################

            $authResultString = "";

            if ($httpUtil->processHTTP($authUrl, $authMap)) {
                $authResultString = $httpUtil->body;
            } else {
                echo "Http Connect Error\n";
                echo $httpUtil->errormsg;

                throw new Exception("Http Connect Error");
            }

            //############################################################
            //5.API 통신결과 처리(***가맹점 개발수정***)
            //############################################################
            echo "## 승인 API 결과 ##";

            $resultMap = json_decode($authResultString, true);
            $tid = $resultMap['tid'];

            $secureMap = array(
                'mid'       =>  $mid,							//mid
                'tstamp'    =>  $timestamp,					//timestemp
                'MOID'      =>  $resultMap["MOID"],         //MOID
                'TotPrice'  =>  $resultMap["TotPrice"],     //TotPrice
                );

            // signature 데이터 생성 
            $secureSignature = $util->makeSignatureAuth($secureMap);

            echo "<pre>";
            echo "<table width='565' border='0' cellspacing='0' cellpadding='0'>";

            if ((strcmp("0000", $resultMap["resultCode"]) == 0) && (strcmp($secureSignature, $resultMap['authSignature']) == 0) ){	//결제보안 추가 2016-05-18
                /*                         * ***************************************************************************
                 * 여기에 가맹점 내부 DB에 결제 결과를 반영하는 관련 프로그램 코드를 구현한다.  

                  [중요!] 승인내용에 이상이 없음을 확인한 뒤 가맹점 DB에 해당건이 정상처리 되었음을 반영함
                  처리중 에러 발생시 망취소를 한다.
                 * **************************************************************************** */

                echo "<tr><th class='td01'><p>거래 성공 여부</p></th>";
                echo "<td class='td02'><p>성공</p></td></tr>";
            } else {
                echo "<tr><th class='td01'><p>거래 성공 여부</p></th>";
                echo "<td class='td02'><p>실패</p></td></tr>";
                echo "<tr><th class='line' colspan='2'><p></p></th></tr>
                    <tr><th class='td01'><p>결과 코드</p></th>
                    <td class='td02'><p>" . @(in_array($resultMap["resultCode"] , $resultMap) ? $resultMap["resultCode"] : "null" ) . "</p></td></tr>";
                
                //결제보안키가 다른 경우.
                if (strcmp($secureSignature, $resultMap["authSignature"]) != 0) {
                    echo "<tr><th class='line' colspan='2'><p></p></th></tr>
                        <tr><th class='td01'><p>결과 내용</p></th>
                        <td class='td02'><p>" . "* 데이터 위변조 체크 실패" . "</p></td></tr>";

                    //망취소
                    if(strcmp("0000", $resultMap["resultCode"]) == 0) {
                        throw new Exception("데이터 위변조 체크 실패");
                    }
                } else {
                    echo "<tr><th class='line' colspan='2'><p></p></th></tr>
                        <tr><th class='td01'><p>결과 내용</p></th>
                        <td class='td02'><p>" . @(in_array($resultMap["resultMsg"] , $resultMap) ? $resultMap["resultMsg"] : "null" ) . "</p></td></tr>";
                }
            }

            //공통 부분만

            // 수신결과를 파싱후 resultCode가 "0000"이면 승인성공 이외 실패
            // 가맹점에서 스스로 파싱후 내부 DB 처리 후 화면에 결과 표시
            // payViewType을 popup으로 해서 결제를 하셨을 경우
            // 내부처리후 스크립트를 이용해 opener의 화면 전환처리를 하세요
            //throw new Exception("강제 Exception");

            $savedata = serialize($resultMap);
            
            $app_no = $resultMap["applNum"]; //승인번호;
            $escw_yn = '';

            $pay_result = array(
                'tot_price' => $resultMap['TotPrice'], //결제완료금액
                'tno' => $resultMap['tid'], //PG 거래번호
                'mid' => $resultMap['mid'], //가맹점 ID ( 테스트 결제인 경우 INIpayTest )
                'vactbankname' => isset($resultMap['vactBankName']) ? $resultMap['vactBankName'] : '',  // 입금할 은행 이름
                'vactname' => isset($resultMap['VACT_Name']) ? $resultMap['VACT_Name'] : '',  // 입금할 계좌 예금주
                'vactnum' => isset($resultMap['VACT_Num']) ? $resultMap['VACT_Num'] : '', // 입금할 계좌 번호
                'vactdate' => isset($resultMap['VACT_Date']) ? $resultMap['VACT_Date'] : '',     // 가상계좌 입금마감시간
            );

            $real_paymethod = isset( $resultMap['payMethod'] ) ? $resultMap['payMethod'] : '';

            if( $real_paymethod && $method_check = gnupay_inicis_payment_check( $order_id, $real_paymethod, $payment_method, $payment_title, $pay_ids ) ){      //payment_method 가 변했는지 체크
                
                if( $method_check['change'] ){
                    $pid = $payment_method = $method_check['payment_method'];
                    $payment_title = $method_check['payment_title'];
                }

            }
            
            if( $payment_method == $pay_ids['bank'] ){  //계좌이체이면
                if( isset($resultMap['ACCT_BankName']) )
                    $pay_result['vactbankname'] = $resultMap['ACCT_BankName'];  // 입금할 은행 이름
                if( isset($resultMap['ACCT_Num']) )
                    $pay_result['vactnum'] = $resultMap['vactnum'];  // 입금할 계좌 번호
            }

            include_once(GNUPAY_INICIS_PATH.'inicis/pay_success_common.php');

            $return_url = $this->get_return_url( $order );

            gp_goto_url($return_url);

            exit;

        } catch (Exception $e) {
            //    $s = $e->getMessage() . ' (오류코드:' . $e->getCode() . ')';
            //####################################
            // 실패시 처리(***가맹점 개발수정***)
            //####################################
            //---- db 저장 실패시 등 예외처리----//
            $s = $e->getMessage() . ' (오류코드:' . $e->getCode() . ')';
            echo $s;

            //#####################
            // 망취소 API
            //#####################

            $netcancelResultString = ""; // 망취소 요청 API url(고정, 임의 세팅 금지)
            if ($httpUtil->processHTTP($netCancel, $authMap)) {
                $netcancelResultString = $httpUtil->body;
            } else {
                echo "Http Connect Error\n";
                echo $httpUtil->errormsg;

                throw new Exception("Http Connect Error");
            }

            echo "## 망취소 API 결과 ##";

            $netcancelResultString = str_replace("<", "&lt;", $$netcancelResultString);
            $netcancelResultString = str_replace(">", "&gt;", $$netcancelResultString);

            echo "<pre>", $netcancelResultString . "</pre>";
            // 취소 결과 확인
        }
    } else {

        //#############
        // 인증 실패시
        //#############
        echo "<br/>";
        echo "####인증실패####";

        echo "<pre>" . var_dump($_REQUEST) . "</pre>";
    }
} catch (Exception $e) {
    $s = $e->getMessage() . ' (오류코드:' . $e->getCode() . ')';
    echo $s;
}
?>