/* global wc_checkout_params */
jQuery( function( $ ) {

	// wc_checkout_params is required to continue, ensure the object exists
	if ( typeof wc_checkout_params === 'undefined' ) {
		return false;
	}
    
    var inicis_checkout_form = {
        $checkout_form: $( 'form.checkout' ),
        $order_review: $( '#order_review' ),
        $inicis_pay_form: $( '#gnupay_inicis_form' ),
		submit_error: function( error_message ) {

            var $form = this.$checkout_form;

			$( '.woocommerce-error, .woocommerce-message' ).remove();
			$form.prepend( error_message );
			$form.removeClass( 'processing' ).unblock();
			$form.find( '.input-text, select' ).blur();

			$( 'html, body' ).animate({
				scrollTop: ( $form.offset().top - 100 )
			}, 1000 );
			$( document.body ).trigger( 'checkout_error' );

		},
        form_set : function(f, json){
            
            console.log( json );

            if(json.shipping_last_name == ''){
                json.shipping_last_name = json.billing_last_name;
            }
            if(json.shipping_first_name == ''){
                json.shipping_first_name = json.billing_first_name;
            }
            if(json.shipping_company == ''){
                json.shipping_company = json.billing_company;
            }
            if(json.shipping_address_1 == ''){
                json.shipping_address_1 = json.billing_address_1;
            }
            if(json.shipping_address_2 == ''){
                json.shipping_address_2 = json.billing_address_2;
            }
            if(json.shipping_city == ''){
                json.shipping_city = json.billing_city;
            }
            if(json.shipping_state == ''){
                json.shipping_state = json.billing_state;
            }
            if(json.shipping_postcode == ''){
                json.shipping_postcode = json.billing_postcode;
            }
            if(json.shipping_country == ''){
                json.shipping_country = json.billing_country;
            }
            if(json.shipping_email == ''){
                json.shipping_email = json.billing_email;
            }
            if(json.shipping_phone == ''){
                json.shipping_phone = json.billing_phone;
            }

            f.order_id.value = json.order_id;    //주문번호
            f.oid.value = json.oid;    //주문번호
            f.order_key.value = json.order_key;
            f.goodsname.value = json.goods;
            f.price.value = json.tot_price;

            if(f.tax !== undefined) f.tax.value = json.comm_vat_mny;
            if(f.taxfree !== undefined) f.taxfree.value = json.comm_free_mny;

            f.buyername.value = json.billing_last_name + json.billing_first_name;
            f.buyeremail.value = json.billing_email;
            f.buyertel.value = json.billing_phone;

            f.recvname.value = json.shipping_last_name + json.shipping_first_name
            f.recvtel.value = json.shipping_phone;
            f.recvpostnum.value = json.shipping_postcode;

            var address_1 = '';
            if( json.shipping_city ){
                address_1 = json.shipping_city + ' ';
            }

            f.recvaddr.value = address_1 + json.shipping_address_1;
            //f.rcvr_add2.value = json.shipping_address_2;

            if(f.timestamp !== undefined) f.timestamp.value = json.timestamp;
            if(f.signature !== undefined) f.signature.value = json.signature;
            if(f.returnUrl !== undefined) f.returnUrl.value = json.returnurl;
            if(f.mKey !== undefined) f.mKey.value = json.mKey;

            if( json.acceptmethod !== undefined) f.acceptmethod.value = json.acceptmethod;

        },
        inicis_mobile_submit : function(f, json){

            var othis = this,
                $woo_form = othis.$checkout_form,
                data_array = $woo_form.serializeArray(),
                result = {};

            $.each( data_array, function() {
                result[this.name] = this.value;
            });

            var settle_method = result.payment_method ? result.payment_method : json.payment_method;
            var mobile_paymethod = "";
            var width = 330;
            var height = 480;
            var xpos = (screen.width - width) / 2;
            var ypos = (screen.width - height) / 2;
            var position = "top=" + ypos + ",left=" + xpos;
            var features = position + ", width=320, height=440";

            switch(settle_method) {
                case "inicis_accounttransfer":    //계좌이체
                    mobile_paymethod = "bank";
                    break;
                case "inicis_virtualaccount": //가상계좌
                    mobile_paymethod = "vbank";
                    break;
                case "inicis_phonepay":   //휴대폰
                    mobile_paymethod = "mobile";
                    break;
                case "inicis_creditcard":     //신용카드
                    mobile_paymethod = "wcard";
                    break;
                case "inicis_easypay":     //간편결제
                    mobile_paymethod = "wcard";
                    f.P_RESERVED.value = p_reserved+"&d_kpay=Y&d_kpay_app=Y";
                    break;
            }

            f.paymethod.value = mobile_paymethod;
            f.P_NOTI.value = f.P_OID.value = json.oid;   //이니시스 mid + 주문번호
            f.oid.value = json.order_id;    //우커머스 주문번호
            f.P_AMT.value = json.tot_price;     //금액
            f.P_UNAME.value = json.billing_last_name + json.billing_first_name;
            
            f.P_NEXT_URL.value = json.next_url;
            f.P_NOTI_URL.value = json.noti_url;
            f.P_MNAME.value = json.p_mname;
            f.P_MOBILE.value = json.billing_phone;
            f.P_EMAIL.value = json.billing_email;

            if( json.de_tax_flag_use ){
                if(f.P_TAX !== undefined) f.P_TAX.value = json.comm_vat_mny;
                if(f.P_TAXFREE !== undefined) f.P_TAXFREE.value = json.comm_free_mny;
            }

            f.P_RETURN_URL.value = json.return_url+'&mobile=1&oid='+json.oid;

            // 주문 정보 임시저장
            var order_data = jQuery(f).serialize();
            
            order_data += "&action="+encodeURIComponent('inicis_orderdatasave');

            var save_result = "";

            jQuery.ajax({
                type: "POST",
                data: order_data,
                url: gnupay_inicis_object.ajaxurl,
                cache: false,
                async: false,
                success: function(data) {
                    save_result = data;
                }
            });

            $woo_form.removeClass( 'processing' ).unblock();

            if(save_result) {
                alert(save_result);
                return false;
            }

            f.action = "https://mobile.inicis.com/smart/" + mobile_paymethod + "/";

            f.submit();

        },
        inicis_pay_submit: function(f, json){

            // 금액체크
            
            var othis = this,
                $woo_form = othis.$checkout_form,
                data_array = $woo_form.serializeArray(),
                result = {};

            $.each( data_array, function() {
                result[this.name] = this.value;
            });

            var payment_method = json.payment_method ? json.payment_method : result.payment_method;

            switch(payment_method) {
                case "inicis_accounttransfer":    //계좌이체
                    f.gopaymethod.value = "DirectBank";
                    break;
                case "inicis_virtualaccount": //가상계좌
                    f.gopaymethod.value = 'Vbank';
                    break;
                case "inicis_phonepay":   //휴대폰
                    f.gopaymethod.value = "HPP";
                    break;
                case "inicis_creditcard":     //신용카드
                    f.gopaymethod.value = "Card";
                    break;
                case "inicis_easypay":     //간편결제
                    f.gopaymethod.value = "EasyPay";
                    if(f.P_RESERVED !== undefined) f.P_RESERVED.value = p_reserved+"&d_kpay=Y&d_kpay_app=Y";
                    break;
            }

            inicis_checkout_form.form_set(f, json);

            $woo_form.removeClass( 'processing' ).unblock();

            return othis.pay( f );

        },
        //Payplus Plug-in 실행/
        pay : function( form )
        {
            INIStdPay.pay( form.id );

            return false;
        }
    }

    // Trigger a handler to let gateways manipulate the checkout if needed
    // inicis 결제를 선택했을 경우에만 실행
    inicis_checkout_form.$checkout_form.on("checkout_place_order_gnupay_inicis checkout_place_order_inicis_creditcard checkout_place_order_inicis_virtualaccount checkout_place_order_inicis_accounttransfer checkout_place_order_inicis_phonepay checkout_place_order_inicis_easypay", gnupay_inicis_checkout_submit);

    inicis_checkout_form.$order_review.on('submit', function(e){

        var payment_method = inicis_checkout_form.$order_review.find( 'input[name="payment_method"]:checked' ).val();
        var methods = ['inicis_creditcard', 'inicis_virtualaccount', 'inicis_accounttransfer', 'inicis_phonepay', 'inicis_easypay'];

        if ( $.inArray(payment_method, methods) !== -1 && typeof gnupay_inicis_object.order_id != "undefined" ){
            e.preventDefault();

            var $form = $( this ),
            formdata = $form.serialize();

            formdata = formdata+'&action=inicis_pay_for_order&order_id='+gnupay_inicis_object.order_id;

            $.ajax({
                type:		'POST',
                url:		gnupay_inicis_object.ajaxurl,
                data:		formdata,
                dataType:   'json',
                success:	function( result ) {

                    if( result.result === 'success' ){
                        if( gnupay_inicis_object.is_mobile ){   //모바일결제

                            inicis_checkout_form.inicis_mobile_submit( inicis_checkout_form.$inicis_pay_form[0], result );

                        } else {    //pc 결제

                            inicis_checkout_form.inicis_pay_submit( inicis_checkout_form.$inicis_pay_form[0], result );

                        }
                    } else {
                        if( result.error_msg !== undefined ){
                            alert( result.error_msg );
                        } else {
                            alert( 'error' );
                        }
                    }
                },
                error:	function( jqXHR, textStatus, errorThrown ) {
                    alert( errorThrown );
                }
            });

            return false;
        }

    });

    function gnupay_inicis_checkout_submit(){
        var $form = $( this );

        if ( $form.is( '.processing' ) ) {
            return false;
        }

        $form.addClass( 'processing' );

        var form_data = $form.data();

        if ( 1 !== form_data['blockUI.isBlocked'] ) {
            $form.block({
                message: null,
                overlayCSS: {
                    background: '#fff',
                    opacity: 0.6
                }
            });
        }

        // ajaxSetup is global, but we use it to ensure JSON is valid once returned.
        $.ajaxSetup( {
            dataFilter: function( raw_response, dataType ) {
                // We only want to work with JSON
                if ( 'json' !== dataType ) {
                    return raw_response;
                }

                try {
                    // check for valid JSON
                    var data = $.parseJSON( raw_response );

                    if ( data && 'object' === typeof data ) {

                        // Valid - return it so it can be parsed by Ajax handler
                        return raw_response;
                    }

                } catch ( e ) {

                    // attempt to fix the malformed JSON
                    var valid_json = raw_response.match( /{"result.*"}/ );

                    if ( null === valid_json ) {
                        //console.log( 'Unable to fix malformed JSON' );
                    } else {
                        //console.log( 'Fixed malformed JSON. Original:' );
                        //console.log( raw_response );
                        raw_response = valid_json[0];
                    }
                }

                return raw_response;
            }
        } );

        $.ajax({
            type:		'POST',
            url:		wc_checkout_params.checkout_url,
            data:		$form.serialize(),
            dataType:   'json',
            success:	function( result ) {

                //inicis_checkout_form.inicis_pay_submit( inicis_checkout_form.$inicis_pay_form[0], result );
                //return;

                try {
                    if ( result.result == 'success' ) {

                        if( gnupay_inicis_object.is_mobile ){   //모바일결제

                            inicis_checkout_form.inicis_mobile_submit( inicis_checkout_form.$inicis_pay_form[0], result );

                        } else {    //pc 결제
                            
                            inicis_checkout_form.inicis_pay_submit( inicis_checkout_form.$inicis_pay_form[0], result );

                        }

                    } else if ( result.result === 'failure' ) {
                        throw 'Result failure';
                    } else {
                        throw 'Invalid response';
                    }
                } catch( err ) {
                    // Reload page
                    if ( result.reload === 'true' ) {
                        window.location.reload();
                        return;
                    }

                    // Trigger update in case we need a fresh nonce
                    if ( result.refresh === 'true' ) {
                        $( document.body ).trigger( 'update_checkout' );
                    }

                    if ( result.messages ) {
                        inicis_checkout_form.submit_error( result.messages );
                    }

                }
            },
            error:	function( jqXHR, textStatus, errorThrown ) {
                inicis_checkout_form.submit_error( '<div class="woocommerce-error">' + errorThrown + '</div>' );
            }
        });

        return false;
    }
});