<?php
if( ! defined( 'ABSPATH' ) ) exit;

//https://docs.woothemes.com/wc-apidocs/class-WC_Order.html

$get_items = $order->get_items();
$od_tno = get_post_meta( $order_id, '_od_tno', true );
$od_receipt_price = get_post_meta( $order_id, '_od_receipt_price', true );
?>
<h2><?php _e('결제정보', GNUPAY_INICIS); ?></h2>
<table class="shop_table order_details">
<tbody>

<?php if($app_no_subj && $od_tno){ ?>
<tr>
    <th scope="row"><?php echo $app_no_subj; ?></th>
    <td><?php echo $app_no; ?></td>
</tr>
<?php } ?>

<tr>
    <th scope="row"><?php _e('결제금액', GNUPAY_INICIS); ?></th>
    <td>
    <?php
    if( $od_receipt_price > 0 ){
        echo wc_price($od_receipt_price);
    } else {
        _e('아직 입금되지 않았거나 입금정보를 입력하지 못하였습니다.', GNUPAY_INICIS);
    }
    ?>
    </td>
</tr>

<?php if($disp_bank && $od_tno){ ?>
<?php if($od_bankname){ ?>
<tr>
    <th scope="row"><?php _e('입금은행', GNUPAY_INICIS); ?></th>
    <td><?php echo esc_attr($od_bankname); ?></td>
</tr>
<?php } ?>
<?php if($od_deposit_name){ ?>
<tr>
    <th scope="row"><?php _e('입금자명', GNUPAY_INICIS); ?></th>
    <td><?php echo esc_attr($od_deposit_name); ?></td>
</tr>
<?php } ?>
<?php if($od_bank_account){ ?>
<tr>
    <th scope="row"><?php _e('입금계좌', GNUPAY_INICIS); ?></th>
    <td><?php echo esc_attr($od_bank_account); ?></td>
</tr>
<?php } ?>
<?php } ?>

<?php if( $disp_receipt && $od_tno ){ ?>
<tr>
    <th scope="row"><?php _e('영수증', GNUPAY_INICIS); ?></th>
    <td>
    <?php
    if($payment_method == $pay_ids['phone']){   //휴대폰
    $hp_receipt_script = 'window.open(\'https://iniweb.inicis.com/DefaultWebApp/mall/cr/cm/mCmReceipt_head.jsp?noTid='.$od['od_tno'].'&noMethod=1\',\'receipt\',\'width=430,height=700\');';
    ?>
    <a href="#" onclick="<?php echo $hp_receipt_script; ?>"><?php _e('영수증 출력', GNUPAY_INICIS); ?></a>
    <?php } ?>
    <?php
    if($payment_method == $pay_ids['card'])  //신용카드
    {
        $card_receipt_script = 'window.open(\'https://iniweb.inicis.com/DefaultWebApp/mall/cr/cm/mCmReceipt_head.jsp?noTid='.$od_tno.'&noMethod=1\',\'receipt\',\'width=430,height=700\');';
    ?>
    <a href="#" onclick="<?php echo $card_receipt_script; ?>"><?php _e('영수증 출력', GNUPAY_INICIS); ?></a>
    <?php
    }
    ?>
    </td>
</tr>
<?php } ?>

<?php
// 현금영수증 발급을 사용하는 경우에만
// 환불된 금액이 없고 현금일 경우에만 현금영수증을 발급 할 수 있습니다. 계좌이체, 가상계좌
if( $payoptions['de_taxsave_use'] && !$order->get_total_refunded() && ($od_receipt_price > 0) && in_array($payment_method, array('inicis_virtualaccount', 'inicis_accounttransfer')) ){

$config = $payoptions;
include_once(GNUPAY_INICIS_PATH.'inicis/settle_inicis.inc.php');
$od_cash = get_post_meta( $order_id, '_od_cash', true );
$cash = get_post_meta( $order_id, '_od_cash_info', true );
?>
<tr>
    <th scope="row"><?php _e('현금영수증', GNUPAY_INICIS); ?></th>
    <td>
        <?php if( $od_cash ){   //현금 영수증을 이미 발급 받았다면
        $default_cash = array('receipt_no'=>'');

        $od_cash_info = maybe_unserialize(get_post_meta($order_id, '_od_cash_info', true));

        $cash = wp_parse_args($od_cash_info, $default_cash);
        $cash_receipt_script = 'window.open(\'https://iniweb.inicis.com/DefaultWebApp/mall/cr/cm/Cash_mCmReceipt.jsp?noTid='.$od_cash_info['TID'].'&clpaymethod=22\',\'showreceipt\',\'width=380,height=540,scrollbars=no,resizable=no\');';

        ?>
        <a href="#" onclick="<?php echo $cash_receipt_script; ?>"><?php _e('현금영수증 확인하기', GNUPAY_INICIS); ?></a>
        <?php } else { ?>
        <a href="#" onclick="window.open('<?php echo add_query_arg(array('wc-api'=>'gnupay_inicis_tax', 'order_id'=>$order_id, 'tx'=>'taxsave'), home_url( '/' )); ?>', 'taxsave', 'width=550,height=600,scrollbars=1,menus=0');"><?php _e('현금영수증 발급', GNUPAY_INICIS); ?></a>
        <?php } ?>
    </td>
</tr>
<?php } ?>
</tbody>
</table>